require 'forwardable'
require 'uri'
require 'mail'

module MailCatcher
  module API
    class Mailbox
      class Message
        extend Forwardable

        def_delegators :@mail, :message_id, :date, :from, :to, :subject, :body, :decode_body,
                       :mime_type, :charset, :content_type

        attr_reader :id, :raw

        def initialize(msg)
          @id = msg['id'].to_i
          @raw = msg['source']

          @mail = Mail.new(@raw)
        end

        def links
          @links ||= URI.extract(decode_body).select { |s| s.start_with?('http') || s.start_with?('https') }
        end

        def delete!
          MailCatcher::API::Client.delete_message(id)
        end
      end
    end
  end
end
